
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "rcfile_y.y"

/*
 * rcfile_y.y -- Run control file parser for fetchmail
 *
 * For license terms, see the file COPYING in this directory.
 */

#include "config.h"

#ifdef MAPI_ENABLE
#include <libmapi/libmapi.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#if defined(__CYGWIN__)
#include <sys/cygwin.h>
#endif /* __CYGWIN__ */

#include "fetchmail.h"
#include "gettext.h"

/* parser reads these */
char *rcfile;			/* path name of rc file */
struct query cmd_opts;		/* where to put command-line info */

/* parser sets these */
struct query *querylist;	/* head of server list (globally visible) */

int yydebug;			/* in case we didn't generate with -- debug */

static struct query current;	/* current server record */
static int prc_errflag;
static struct hostdata *leadentry;
static flag trailer;

static void record_current(void);
static void user_reset(void);
static void reset_server(const char *name, int skip);

/* these should be of size PATH_MAX */
char currentwd[1024] = "", rcfiledir[1024] = "";

/* using Bison, this arranges that yydebug messages will show actual tokens */
extern char * yytext;
#define YYPRINT(fp, type, val)	fprintf(fp, " = \"%s\"", yytext)


/* Line 189 of yacc.c  */
#line 130 "rcfile_y.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     DEFAULTS = 258,
     POLL = 259,
     SKIP = 260,
     VIA = 261,
     AKA = 262,
     LOCALDOMAINS = 263,
     PROTOCOL = 264,
     AUTHENTICATE = 265,
     TIMEOUT = 266,
     KPOP = 267,
     SDPS = 268,
     ENVELOPE = 269,
     QVIRTUAL = 270,
     PINENTRY_TIMEOUT = 271,
     PWMD_SOCKET = 272,
     PWMD_FILE = 273,
     USERNAME = 274,
     PASSWORD = 275,
     FOLDER = 276,
     SMTPHOST = 277,
     FETCHDOMAINS = 278,
     MDA = 279,
     BSMTP = 280,
     LMTP = 281,
     SMTPADDRESS = 282,
     SMTPNAME = 283,
     SPAMRESPONSE = 284,
     PRECONNECT = 285,
     POSTCONNECT = 286,
     LIMIT = 287,
     WARNINGS = 288,
     INTERFACE = 289,
     MONITOR = 290,
     PLUGIN = 291,
     PLUGOUT = 292,
     IS = 293,
     HERE = 294,
     THERE = 295,
     TO = 296,
     MAP = 297,
     BATCHLIMIT = 298,
     FETCHLIMIT = 299,
     FETCHSIZELIMIT = 300,
     FASTUIDL = 301,
     EXPUNGE = 302,
     PROPERTIES = 303,
     SET = 304,
     LOGFILE = 305,
     DAEMON = 306,
     SYSLOG = 307,
     IDFILE = 308,
     PIDFILE = 309,
     INVISIBLE = 310,
     POSTMASTER = 311,
     BOUNCEMAIL = 312,
     SPAMBOUNCE = 313,
     SOFTBOUNCE = 314,
     SHOWDOTS = 315,
     BADHEADER = 316,
     ACCEPT = 317,
     REJECT_ = 318,
     RETRIEVEERROR = 319,
     ABORT = 320,
     CONTINUE = 321,
     MARKSEEN = 322,
     PROTO = 323,
     AUTHTYPE = 324,
     STRING = 325,
     NUMBER = 326,
     NO = 327,
     KEEP = 328,
     FLUSH = 329,
     LIMITFLUSH = 330,
     FETCHALL = 331,
     REWRITE = 332,
     FORCECR = 333,
     STRIPCR = 334,
     PASS8BITS = 335,
     DROPSTATUS = 336,
     DROPDELIVERED = 337,
     DNS = 338,
     SERVICE = 339,
     PORT = 340,
     UIDL = 341,
     INTERVAL = 342,
     MIMEDECODE = 343,
     IDLE = 344,
     CHECKALIAS = 345,
     SSL = 346,
     SSLKEY = 347,
     SSLCERT = 348,
     SSLPROTO = 349,
     SSLCERTCK = 350,
     SSLCERTFILE = 351,
     SSLCERTPATH = 352,
     SSLCOMMONNAME = 353,
     SSLFINGERPRINT = 354,
     PRINCIPAL = 355,
     ESMTPNAME = 356,
     ESMTPPASSWORD = 357,
     TRACEPOLLS = 358,
     MAPI_WORKSTATION = 359,
     MAPI_DOMAIN = 360,
     MAPI_LCID = 361,
     MAPI_LDIF = 362,
     MAPI_PROFDB = 363,
     MAPI_PROFNAME = 364
   };
#endif
/* Tokens.  */
#define DEFAULTS 258
#define POLL 259
#define SKIP 260
#define VIA 261
#define AKA 262
#define LOCALDOMAINS 263
#define PROTOCOL 264
#define AUTHENTICATE 265
#define TIMEOUT 266
#define KPOP 267
#define SDPS 268
#define ENVELOPE 269
#define QVIRTUAL 270
#define PINENTRY_TIMEOUT 271
#define PWMD_SOCKET 272
#define PWMD_FILE 273
#define USERNAME 274
#define PASSWORD 275
#define FOLDER 276
#define SMTPHOST 277
#define FETCHDOMAINS 278
#define MDA 279
#define BSMTP 280
#define LMTP 281
#define SMTPADDRESS 282
#define SMTPNAME 283
#define SPAMRESPONSE 284
#define PRECONNECT 285
#define POSTCONNECT 286
#define LIMIT 287
#define WARNINGS 288
#define INTERFACE 289
#define MONITOR 290
#define PLUGIN 291
#define PLUGOUT 292
#define IS 293
#define HERE 294
#define THERE 295
#define TO 296
#define MAP 297
#define BATCHLIMIT 298
#define FETCHLIMIT 299
#define FETCHSIZELIMIT 300
#define FASTUIDL 301
#define EXPUNGE 302
#define PROPERTIES 303
#define SET 304
#define LOGFILE 305
#define DAEMON 306
#define SYSLOG 307
#define IDFILE 308
#define PIDFILE 309
#define INVISIBLE 310
#define POSTMASTER 311
#define BOUNCEMAIL 312
#define SPAMBOUNCE 313
#define SOFTBOUNCE 314
#define SHOWDOTS 315
#define BADHEADER 316
#define ACCEPT 317
#define REJECT_ 318
#define RETRIEVEERROR 319
#define ABORT 320
#define CONTINUE 321
#define MARKSEEN 322
#define PROTO 323
#define AUTHTYPE 324
#define STRING 325
#define NUMBER 326
#define NO 327
#define KEEP 328
#define FLUSH 329
#define LIMITFLUSH 330
#define FETCHALL 331
#define REWRITE 332
#define FORCECR 333
#define STRIPCR 334
#define PASS8BITS 335
#define DROPSTATUS 336
#define DROPDELIVERED 337
#define DNS 338
#define SERVICE 339
#define PORT 340
#define UIDL 341
#define INTERVAL 342
#define MIMEDECODE 343
#define IDLE 344
#define CHECKALIAS 345
#define SSL 346
#define SSLKEY 347
#define SSLCERT 348
#define SSLPROTO 349
#define SSLCERTCK 350
#define SSLCERTFILE 351
#define SSLCERTPATH 352
#define SSLCOMMONNAME 353
#define SSLFINGERPRINT 354
#define PRINCIPAL 355
#define ESMTPNAME 356
#define ESMTPPASSWORD 357
#define TRACEPOLLS 358
#define MAPI_WORKSTATION 359
#define MAPI_DOMAIN 360
#define MAPI_LCID 361
#define MAPI_LDIF 362
#define MAPI_PROFDB 363
#define MAPI_PROFNAME 364




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 57 "rcfile_y.y"

  int proto;
  int number;
  char *sval;



/* Line 214 of yacc.c  */
#line 392 "rcfile_y.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 404 "rcfile_y.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  25
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   333

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  110
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  23
/* YYNRULES -- Number of rules.  */
#define YYNRULES  165
/* YYNRULES -- Number of states.  */
#define YYNSTATES  247

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   364

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    13,    14,    19,
      24,    29,    34,    39,    42,    46,    49,    53,    56,    60,
      65,    68,    72,    75,    79,    82,    86,    91,    94,    98,
     103,   106,   109,   111,   112,   115,   117,   120,   122,   125,
     128,   131,   134,   137,   140,   143,   146,   149,   152,   154,
     157,   159,   162,   165,   168,   171,   174,   177,   180,   184,
     187,   190,   193,   196,   199,   202,   204,   207,   210,   212,
     215,   218,   221,   224,   227,   230,   232,   234,   236,   239,
     242,   245,   249,   253,   254,   257,   259,   262,   264,   267,
     269,   273,   275,   278,   280,   283,   285,   288,   290,   293,
     297,   300,   304,   307,   311,   314,   317,   320,   323,   326,
     329,   332,   335,   338,   340,   343,   346,   348,   350,   352,
     354,   356,   358,   360,   362,   364,   366,   368,   370,   372,
     375,   378,   381,   383,   386,   389,   392,   395,   398,   401,
     404,   407,   410,   413,   416,   419,   422,   425,   428,   431,
     434,   437,   440,   443,   446,   449,   452,   455,   458,   461,
     464,   467,   470,   473,   476,   479
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     111,     0,    -1,    -1,   112,    -1,   114,    -1,   112,   114,
      -1,    42,    -1,    -1,    49,    50,   113,    70,    -1,    49,
      53,   113,    70,    -1,    49,    54,   113,    70,    -1,    49,
      51,   113,    71,    -1,    49,    56,   113,    70,    -1,    49,
      57,    -1,    49,    72,    57,    -1,    49,    58,    -1,    49,
      72,    58,    -1,    49,    59,    -1,    49,    72,    59,    -1,
      49,    48,   113,    70,    -1,    49,    52,    -1,    49,    72,
      52,    -1,    49,    55,    -1,    49,    72,    55,    -1,    49,
      60,    -1,    49,    72,    60,    -1,    49,    16,   113,    71,
      -1,   115,   116,    -1,   115,   116,   120,    -1,   115,   116,
     120,   119,    -1,     4,    70,    -1,     5,    70,    -1,     3,
      -1,    -1,   116,   119,    -1,    70,    -1,   117,    70,    -1,
      70,    -1,   118,    70,    -1,     7,   117,    -1,     6,    70,
      -1,     8,   118,    -1,     9,    68,    -1,     9,    12,    -1,
     100,    70,    -1,   101,    70,    -1,   102,    70,    -1,     9,
      13,    -1,    86,    -1,    72,    86,    -1,    90,    -1,    72,
      90,    -1,    84,    70,    -1,    84,    71,    -1,    85,    71,
      -1,    87,    71,    -1,    10,    69,    -1,    11,    71,    -1,
      14,    71,    70,    -1,    14,    70,    -1,    15,    70,    -1,
      34,    70,    -1,    35,    70,    -1,    36,    70,    -1,    37,
      70,    -1,    83,    -1,    72,    83,    -1,    72,    14,    -1,
     103,    -1,    72,   103,    -1,    61,    62,    -1,    61,    63,
      -1,    64,    65,    -1,    64,    66,    -1,    64,    67,    -1,
     125,    -1,   121,    -1,   122,    -1,   121,   122,    -1,   123,
     124,    -1,    19,    70,    -1,    19,   126,    39,    -1,    19,
      70,    40,    -1,    -1,   124,   132,    -1,   132,    -1,   125,
     132,    -1,   127,    -1,   126,   127,    -1,    70,    -1,    70,
      42,    70,    -1,    70,    -1,   128,    70,    -1,    70,    -1,
     129,    70,    -1,    70,    -1,   130,    70,    -1,    71,    -1,
     131,    71,    -1,    41,   126,    39,    -1,    41,   126,    -1,
      38,   126,    39,    -1,    38,   126,    -1,    38,    70,    40,
      -1,    20,    70,    -1,    21,   128,    -1,    22,   129,    -1,
      23,   130,    -1,    27,    70,    -1,    28,    70,    -1,    29,
     131,    -1,    24,    70,    -1,    25,    70,    -1,    26,    -1,
      30,    70,    -1,    31,    70,    -1,    73,    -1,    74,    -1,
      75,    -1,    76,    -1,    77,    -1,    78,    -1,    79,    -1,
      80,    -1,    81,    -1,    82,    -1,    88,    -1,    89,    -1,
      91,    -1,    92,    70,    -1,    93,    70,    -1,    94,    70,
      -1,    95,    -1,    96,    70,    -1,    97,    70,    -1,    98,
      70,    -1,    99,    70,    -1,    72,    73,    -1,    72,    74,
      -1,    72,    75,    -1,    72,    76,    -1,    72,    77,    -1,
      72,    78,    -1,    72,    79,    -1,    72,    80,    -1,    72,
      81,    -1,    72,    82,    -1,    72,    88,    -1,    72,    89,
      -1,    72,    91,    -1,    32,    71,    -1,    33,    71,    -1,
      44,    71,    -1,    45,    71,    -1,    46,    71,    -1,    43,
      71,    -1,    47,    71,    -1,    48,    70,    -1,    17,    70,
      -1,    18,    70,    -1,   104,    70,    -1,   105,    70,    -1,
     106,    70,    -1,   107,    70,    -1,   108,    70,    -1,   109,
      70,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    93,    93,    94,    97,    98,   101,   101,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   136,   137,   140,
     144,   145,   146,   149,   150,   153,   154,   157,   158,   161,
     162,   163,   164,   165,   175,   176,   177,   178,   186,   187,
     188,   189,   190,   193,   199,   205,   207,   209,   211,   216,
     222,   223,   231,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   253,   254,   257,   258,   261,
     264,   265,   266,   269,   270,   273,   274,   277,   278,   281,
     287,   290,   291,   294,   295,   298,   299,   302,   308,   316,
     317,   318,   319,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   348,   355,
     356,   357,   358,   359,   360,   361,   362,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   377,
     379,   380,   381,   382,   383,   384,   385,   387,   389,   397,
     406,   413,   424,   453,   460,   467
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DEFAULTS", "POLL", "SKIP", "VIA", "AKA",
  "LOCALDOMAINS", "PROTOCOL", "AUTHENTICATE", "TIMEOUT", "KPOP", "SDPS",
  "ENVELOPE", "QVIRTUAL", "PINENTRY_TIMEOUT", "PWMD_SOCKET", "PWMD_FILE",
  "USERNAME", "PASSWORD", "FOLDER", "SMTPHOST", "FETCHDOMAINS", "MDA",
  "BSMTP", "LMTP", "SMTPADDRESS", "SMTPNAME", "SPAMRESPONSE", "PRECONNECT",
  "POSTCONNECT", "LIMIT", "WARNINGS", "INTERFACE", "MONITOR", "PLUGIN",
  "PLUGOUT", "IS", "HERE", "THERE", "TO", "MAP", "BATCHLIMIT",
  "FETCHLIMIT", "FETCHSIZELIMIT", "FASTUIDL", "EXPUNGE", "PROPERTIES",
  "SET", "LOGFILE", "DAEMON", "SYSLOG", "IDFILE", "PIDFILE", "INVISIBLE",
  "POSTMASTER", "BOUNCEMAIL", "SPAMBOUNCE", "SOFTBOUNCE", "SHOWDOTS",
  "BADHEADER", "ACCEPT", "REJECT_", "RETRIEVEERROR", "ABORT", "CONTINUE",
  "MARKSEEN", "PROTO", "AUTHTYPE", "STRING", "NUMBER", "NO", "KEEP",
  "FLUSH", "LIMITFLUSH", "FETCHALL", "REWRITE", "FORCECR", "STRIPCR",
  "PASS8BITS", "DROPSTATUS", "DROPDELIVERED", "DNS", "SERVICE", "PORT",
  "UIDL", "INTERVAL", "MIMEDECODE", "IDLE", "CHECKALIAS", "SSL", "SSLKEY",
  "SSLCERT", "SSLPROTO", "SSLCERTCK", "SSLCERTFILE", "SSLCERTPATH",
  "SSLCOMMONNAME", "SSLFINGERPRINT", "PRINCIPAL", "ESMTPNAME",
  "ESMTPPASSWORD", "TRACEPOLLS", "MAPI_WORKSTATION", "MAPI_DOMAIN",
  "MAPI_LCID", "MAPI_LDIF", "MAPI_PROFDB", "MAPI_PROFNAME", "$accept",
  "rcfile", "statement_list", "optmap", "statement", "define_server",
  "serverspecs", "alias_list", "domain_list", "serv_option", "userspecs",
  "explicits", "explicitdef", "userdef", "user0opts", "user1opts",
  "mapping_list", "mapping", "folder_list", "smtp_list", "fetch_list",
  "num_list", "user_option", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   110,   111,   111,   112,   112,   113,   113,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     115,   115,   115,   116,   116,   117,   117,   118,   118,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   120,   120,   121,   121,   122,
     123,   123,   123,   124,   124,   125,   125,   126,   126,   127,
     127,   128,   128,   129,   129,   130,   130,   131,   131,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     0,     4,     4,
       4,     4,     4,     2,     3,     2,     3,     2,     3,     4,
       2,     3,     2,     3,     2,     3,     4,     2,     3,     4,
       2,     2,     1,     0,     2,     1,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     2,     2,
       2,     3,     3,     0,     2,     1,     2,     1,     2,     1,
       3,     1,     2,     1,     2,     1,     2,     1,     2,     3,
       2,     3,     2,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    32,     0,     0,     0,     0,     3,     4,    33,    30,
      31,     7,     7,     7,     7,    20,     7,     7,    22,     7,
      13,    15,    17,    24,     0,     1,     5,    27,     6,     0,
       0,     0,     0,     0,     0,     0,    21,    23,    14,    16,
      18,    25,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   113,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,    65,     0,     0,    48,     0,   126,   127,    50,
     128,     0,     0,     0,   132,     0,     0,     0,     0,     0,
       0,     0,    68,     0,     0,     0,     0,     0,     0,    34,
      28,    76,    77,    83,    75,    85,    26,    19,     8,    11,
       9,    10,    12,    40,    35,    39,    37,    41,    43,    47,
      42,    56,    57,    59,     0,    60,   158,   159,    80,     0,
      87,   104,    91,   105,    93,   106,    95,   107,   111,   112,
     108,   109,    97,   110,   114,   115,   150,   151,    61,    62,
      63,    64,    89,   102,    89,   100,   155,   152,   153,   154,
     156,   157,    70,    71,    72,    73,    74,    67,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,    66,    49,
     147,   148,    51,   149,    69,    52,    53,    54,    55,   129,
     130,   131,   133,   134,   135,   136,    44,    45,    46,   160,
     161,   162,   163,   164,   165,     0,    29,    78,    79,     0,
      86,    36,    38,    58,    82,     0,    81,    88,    92,    94,
      96,    98,   103,   101,    99,    84,    90
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,    29,     7,     8,    27,   135,   137,   119,
     120,   121,   122,   123,   228,   124,   149,   150,   153,   155,
     157,   163,   125
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -140
static const yytype_int16 yypact[] =
{
       0,  -140,   -62,   -55,   133,    19,     0,  -140,  -140,  -140,
    -140,    -7,    -7,    -7,    -7,  -140,    -7,    -7,  -140,    -7,
    -140,  -140,  -140,  -140,   -34,  -140,  -140,    33,  -140,     2,
     -32,   -24,    21,     5,    28,    29,  -140,  -140,  -140,  -140,
    -140,  -140,    30,    31,    80,     4,    34,    82,   -59,    84,
      85,    86,    88,    89,   100,   107,   109,   110,   112,  -140,
     124,   125,   126,   129,   130,   131,   132,   134,   136,   138,
     140,   141,   142,   143,   144,   145,   146,   148,   155,   -35,
     -36,   204,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,    13,   157,  -140,   158,  -140,  -140,  -140,
    -140,   156,   160,   161,  -140,   162,   163,   164,   165,   166,
     173,   188,  -140,   189,   190,   191,   193,   194,   196,  -140,
     137,   177,  -140,  -140,   224,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,   203,  -140,   205,  -140,  -140,
    -140,  -140,  -140,  -140,   206,  -140,  -140,  -140,   -33,   -38,
    -140,  -140,  -140,   218,  -140,   219,  -140,   221,  -140,  -140,
    -140,  -140,  -140,   237,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,   -20,   -37,   115,   -25,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,    -1,  -140,  -140,   224,    87,
    -140,  -140,  -140,  -140,  -140,   239,  -140,  -140,  -140,  -140,
    -140,  -140,  -140,  -140,  -140,  -140,  -140
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -140,  -140,  -140,    74,   201,  -140,  -140,  -140,  -140,    93,
    -140,  -140,   153,  -140,  -140,  -140,    24,  -139,  -140,  -140,
    -140,  -140,  -124
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -90
static const yytype_int16 yytable[] =
{
     230,   236,   243,     1,     2,     3,   -89,   234,     9,   235,
     237,   143,   144,   187,   244,    10,   138,   139,    36,    25,
     242,    37,   235,    38,    39,    40,    41,   182,   183,   184,
     185,   186,   174,   174,   237,    28,   237,   -89,   127,    42,
      43,    44,    45,    46,    47,   174,   128,    48,    49,     4,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,   140,   126,    72,   130,    73,    74,    75,    76,
      77,    78,   198,   205,   206,   199,    30,    31,    32,   202,
      33,    34,   129,    35,    79,   173,   175,    80,   131,   132,
     133,   134,   204,   141,   245,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    42,    43,    44,    45,    46,    47,    11,
     136,    48,    49,   142,   145,   146,   147,   235,   148,   151,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     152,    67,    68,    69,    70,   200,   201,   154,   203,   156,
     158,    12,   159,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,   160,   161,    52,   162,    79,   164,
     165,    80,   166,   167,   168,    24,   169,    26,   170,   225,
     171,   172,   174,   226,   176,   177,   178,   179,   187,   180,
      92,    93,    94,    95,    96,   181,   209,    99,   207,   208,
     210,   211,   212,   213,   214,   215,   216,   109,   110,   111,
     112,    50,    51,   217,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,   218,   219,
     220,   221,    71,   222,   223,    72,   224,    73,    74,    75,
      76,    77,    78,   231,   227,   232,   233,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   238,   239,
     199,   240,   200,   201,   202,   203,   229,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,   204,   241,   246,
       0,     0,    97,    98,     0,   100,   101,   102,   103,   104,
     105,   106,   107,   108,     0,     0,     0,     0,   113,   114,
     115,   116,   117,   118
};

static const yytype_int16 yycheck[] =
{
     124,    39,    39,     3,     4,     5,    39,    40,    70,    42,
     149,    70,    71,    14,    39,    70,    12,    13,    52,     0,
      40,    55,    42,    57,    58,    59,    60,    62,    63,    65,
      66,    67,    70,    70,   173,    42,   175,    70,    70,     6,
       7,     8,     9,    10,    11,    70,    70,    14,    15,    49,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    68,    71,    41,    70,    43,    44,    45,    46,
      47,    48,    83,    70,    71,    86,    12,    13,    14,    90,
      16,    17,    71,    19,    61,    71,    72,    64,    70,    70,
      70,    70,   103,    69,   228,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     6,     7,     8,     9,    10,    11,    16,
      70,    14,    15,    71,    70,    70,    70,    42,    70,    70,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      70,    34,    35,    36,    37,    88,    89,    70,    91,    70,
      70,    48,    70,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    70,    70,    19,    71,    61,    70,
      70,    64,    71,    71,    70,    72,    70,     6,    70,    72,
      70,    70,    70,   120,    71,    71,    71,    71,    14,    71,
      83,    84,    85,    86,    87,    70,    70,    90,    71,    71,
      70,    70,    70,    70,    70,    70,    70,   100,   101,   102,
     103,    17,    18,    70,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    70,    70,
      70,    70,    38,    70,    70,    41,    70,    43,    44,    45,
      46,    47,    48,    70,   121,    70,    70,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    70,    70,
      86,    70,    88,    89,    90,    91,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,   103,    71,    70,
      -1,    -1,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,   107,   108,   109
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,    49,   111,   112,   114,   115,    70,
      70,    16,    48,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    72,     0,   114,   116,    42,   113,
     113,   113,   113,   113,   113,   113,    52,    55,    57,    58,
      59,    60,     6,     7,     8,     9,    10,    11,    14,    15,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    41,    43,    44,    45,    46,    47,    48,    61,
      64,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   119,
     120,   121,   122,   123,   125,   132,    71,    70,    70,    71,
      70,    70,    70,    70,    70,   117,    70,   118,    12,    13,
      68,    69,    71,    70,    71,    70,    70,    70,    70,   126,
     127,    70,    70,   128,    70,   129,    70,   130,    70,    70,
      70,    70,    71,   131,    70,    70,    71,    71,    70,    70,
      70,    70,    70,   126,    70,   126,    71,    71,    71,    71,
      71,    70,    62,    63,    65,    66,    67,    14,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    86,
      88,    89,    90,    91,   103,    70,    71,    71,    71,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    72,   119,   122,   124,    72,
     132,    70,    70,    70,    40,    42,    39,   127,    70,    70,
      70,    71,    40,    39,    39,   132,    70
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 70: /* "STRING" */

/* Line 1000 of yacc.c  */
#line 89 "rcfile_y.y"
	{ free ((yyvaluep->sval)); };

/* Line 1000 of yacc.c  */
#line 1582 "rcfile_y.c"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:

/* Line 1455 of yacc.c  */
#line 104 "rcfile_y.y"
    {run.logfile = prependdir ((yyvsp[(4) - (4)].sval), rcfiledir); free((yyvsp[(4) - (4)].sval));}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 105 "rcfile_y.y"
    {run.idfile = prependdir ((yyvsp[(4) - (4)].sval), rcfiledir); free((yyvsp[(4) - (4)].sval));}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 106 "rcfile_y.y"
    {run.pidfile = prependdir ((yyvsp[(4) - (4)].sval), rcfiledir); free((yyvsp[(4) - (4)].sval));}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 107 "rcfile_y.y"
    {run.poll_interval = (yyvsp[(4) - (4)].number);}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 108 "rcfile_y.y"
    {run.postmaster = (yyvsp[(4) - (4)].sval);}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 109 "rcfile_y.y"
    {run.bouncemail = TRUE;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 110 "rcfile_y.y"
    {run.bouncemail = FALSE;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 111 "rcfile_y.y"
    {run.spambounce = TRUE;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 112 "rcfile_y.y"
    {run.spambounce = FALSE;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 113 "rcfile_y.y"
    {run.softbounce = TRUE;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 114 "rcfile_y.y"
    {run.softbounce = FALSE;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 115 "rcfile_y.y"
    {run.properties = (yyvsp[(4) - (4)].sval);}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 116 "rcfile_y.y"
    {run.use_syslog = TRUE;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 117 "rcfile_y.y"
    {run.use_syslog = FALSE;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 118 "rcfile_y.y"
    {run.invisible = TRUE;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 119 "rcfile_y.y"
    {run.invisible = FALSE;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 120 "rcfile_y.y"
    {run.showdots = FLAG_TRUE;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 121 "rcfile_y.y"
    {run.showdots = FLAG_FALSE;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 122 "rcfile_y.y"
    {
#ifdef HAVE_LIBPWMD
		    run.pinentry_timeout = (yyvsp[(4) - (4)].number);
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
		    }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 136 "rcfile_y.y"
    {record_current();}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 141 "rcfile_y.y"
    {yyerror(GT_("server option after user options"));}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 144 "rcfile_y.y"
    {reset_server((yyvsp[(2) - (2)].sval), FALSE); free((yyvsp[(2) - (2)].sval));}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 145 "rcfile_y.y"
    {reset_server((yyvsp[(2) - (2)].sval), TRUE);  free((yyvsp[(2) - (2)].sval));}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 146 "rcfile_y.y"
    {reset_server("defaults", FALSE);}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 153 "rcfile_y.y"
    {save_str(&current.server.akalist,(yyvsp[(1) - (1)].sval),0); free((yyvsp[(1) - (1)].sval));}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 154 "rcfile_y.y"
    {save_str(&current.server.akalist,(yyvsp[(2) - (2)].sval),0); free((yyvsp[(2) - (2)].sval));}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 157 "rcfile_y.y"
    {save_str(&current.server.localdomains,(yyvsp[(1) - (1)].sval),0); free((yyvsp[(1) - (1)].sval));}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 158 "rcfile_y.y"
    {save_str(&current.server.localdomains,(yyvsp[(2) - (2)].sval),0); free((yyvsp[(2) - (2)].sval));}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 162 "rcfile_y.y"
    {current.server.via = (yyvsp[(2) - (2)].sval);}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 164 "rcfile_y.y"
    {current.server.protocol = (yyvsp[(2) - (2)].proto);}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 165 "rcfile_y.y"
    {
					    current.server.protocol = P_POP3;
#ifdef KERBEROS_V5
					    if (current.server.authenticate == A_PASSWORD)
						current.server.authenticate = A_KERBEROS_V5;
					    current.server.service = KPOP_PORT;
#else
					    yyerror(GT_("Kerberos not enabled."));
#endif
					}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 175 "rcfile_y.y"
    {current.server.principal = (yyvsp[(2) - (2)].sval);}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 176 "rcfile_y.y"
    {current.server.esmtp_name = (yyvsp[(2) - (2)].sval);}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 177 "rcfile_y.y"
    {current.server.esmtp_password = (yyvsp[(2) - (2)].sval);}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 178 "rcfile_y.y"
    {
#ifdef SDPS_ENABLE
					    current.server.protocol = P_POP3;
					    current.server.sdps = TRUE;
#else
					    yyerror(GT_("SDPS not enabled."));
#endif /* SDPS_ENABLE */
					}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 186 "rcfile_y.y"
    {/* EMPTY - removed in 7.0.0 */}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 187 "rcfile_y.y"
    {/* EMPTY - removed in 7.0.0 */}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 188 "rcfile_y.y"
    {current.server.checkalias = FLAG_TRUE;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 189 "rcfile_y.y"
    {current.server.checkalias  = FLAG_FALSE;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 190 "rcfile_y.y"
    {
					current.server.service = (yyvsp[(2) - (2)].sval);
					}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 193 "rcfile_y.y"
    {
					int port = (yyvsp[(2) - (2)].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 199 "rcfile_y.y"
    {
					int port = (yyvsp[(2) - (2)].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 206 "rcfile_y.y"
    {current.server.interval = (yyvsp[(2) - (2)].number);}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 208 "rcfile_y.y"
    {current.server.authenticate = (yyvsp[(2) - (2)].proto);}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 210 "rcfile_y.y"
    {current.server.timeout = (yyvsp[(2) - (2)].number);}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 212 "rcfile_y.y"
    {
					    current.server.envelope = (yyvsp[(3) - (3)].sval);
					    current.server.envskip = (yyvsp[(2) - (3)].number);
					}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 217 "rcfile_y.y"
    {
					    current.server.envelope = (yyvsp[(2) - (2)].sval);
					    current.server.envskip = 0;
					}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 222 "rcfile_y.y"
    {current.server.qvirtual = (yyvsp[(2) - (2)].sval);}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 223 "rcfile_y.y"
    {
#ifdef CAN_MONITOR
					interface_parse((yyvsp[(2) - (2)].sval), &current.server);
#else
					fprintf(stderr, GT_("fetchmail: interface option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif
					free((yyvsp[(2) - (2)].sval));
					}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 231 "rcfile_y.y"
    {
#ifdef CAN_MONITOR
					current.server.monitor = (yyvsp[(2) - (2)].sval);
#else
					fprintf(stderr, GT_("fetchmail: monitor option is only supported under Linux (without IPv6) and FreeBSD\n"));
					free((yyvsp[(2) - (2)].sval));
#endif
					}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 239 "rcfile_y.y"
    { current.server.plugin = (yyvsp[(2) - (2)].sval); }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 240 "rcfile_y.y"
    { current.server.plugout = (yyvsp[(2) - (2)].sval); }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 241 "rcfile_y.y"
    {current.server.dns = FLAG_TRUE;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 242 "rcfile_y.y"
    {current.server.dns = FLAG_FALSE;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 243 "rcfile_y.y"
    {current.server.envelope = STRING_DISABLED;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 244 "rcfile_y.y"
    {current.server.tracepolls = FLAG_TRUE;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 245 "rcfile_y.y"
    {current.server.tracepolls = FLAG_FALSE;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 246 "rcfile_y.y"
    {current.server.badheader = BHACCEPT;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 247 "rcfile_y.y"
    {current.server.badheader = BHREJECT;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 248 "rcfile_y.y"
    {current.server.retrieveerror = RE_ABORT;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 249 "rcfile_y.y"
    {current.server.retrieveerror = RE_CONTINUE;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 250 "rcfile_y.y"
    {current.server.retrieveerror = RE_MARKSEEN;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 253 "rcfile_y.y"
    {record_current(); user_reset();}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 257 "rcfile_y.y"
    {record_current(); user_reset();}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 258 "rcfile_y.y"
    {record_current(); user_reset();}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 264 "rcfile_y.y"
    {current.remotename = (yyvsp[(2) - (2)].sval);}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 266 "rcfile_y.y"
    {current.remotename = (yyvsp[(2) - (3)].sval);}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 281 "rcfile_y.y"
    {if (0 == strcmp((yyvsp[(1) - (1)].sval), "*")) {
					      current.wildcard = TRUE;
					  } else {
					    save_str_pair(&current.localnames, (yyvsp[(1) - (1)].sval), NULL);
					  }
					 free((yyvsp[(1) - (1)].sval));}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 287 "rcfile_y.y"
    {save_str_pair(&current.localnames, (yyvsp[(1) - (3)].sval), (yyvsp[(3) - (3)].sval)); free((yyvsp[(1) - (3)].sval)); free((yyvsp[(3) - (3)].sval));}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 290 "rcfile_y.y"
    {save_str(&current.mailboxes,(yyvsp[(1) - (1)].sval),0); free((yyvsp[(1) - (1)].sval));}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 291 "rcfile_y.y"
    {save_str(&current.mailboxes,(yyvsp[(2) - (2)].sval),0); free((yyvsp[(2) - (2)].sval));}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 294 "rcfile_y.y"
    {save_str(&current.smtphunt, (yyvsp[(1) - (1)].sval),TRUE); free((yyvsp[(1) - (1)].sval));}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 295 "rcfile_y.y"
    {save_str(&current.smtphunt, (yyvsp[(2) - (2)].sval),TRUE); free((yyvsp[(2) - (2)].sval));}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 298 "rcfile_y.y"
    {save_str(&current.domainlist, (yyvsp[(1) - (1)].sval),TRUE); free((yyvsp[(1) - (1)].sval));}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 299 "rcfile_y.y"
    {save_str(&current.domainlist, (yyvsp[(2) - (2)].sval),TRUE); free((yyvsp[(2) - (2)].sval));}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 303 "rcfile_y.y"
    {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[(1) - (1)].number);
			}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 309 "rcfile_y.y"
    {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[(2) - (2)].number);
			}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 321 "rcfile_y.y"
    {current.remotename  = (yyvsp[(2) - (3)].sval);}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 322 "rcfile_y.y"
    {current.password    = (yyvsp[(2) - (2)].sval);}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 326 "rcfile_y.y"
    {current.smtpaddress = (yyvsp[(2) - (2)].sval);}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 327 "rcfile_y.y"
    {current.smtpname =    (yyvsp[(2) - (2)].sval);}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 329 "rcfile_y.y"
    {current.mda         = (yyvsp[(2) - (2)].sval);}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 330 "rcfile_y.y"
    {current.bsmtp       = prependdir ((yyvsp[(2) - (2)].sval), rcfiledir); free((yyvsp[(2) - (2)].sval));}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 331 "rcfile_y.y"
    {current.listener    = LMTP_MODE;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 332 "rcfile_y.y"
    {current.preconnect  = (yyvsp[(2) - (2)].sval);}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 333 "rcfile_y.y"
    {current.postconnect = (yyvsp[(2) - (2)].sval);}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 335 "rcfile_y.y"
    {current.keep        = FLAG_TRUE;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 336 "rcfile_y.y"
    {current.flush       = FLAG_TRUE;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 337 "rcfile_y.y"
    {current.limitflush  = FLAG_TRUE;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 338 "rcfile_y.y"
    {current.fetchall    = FLAG_TRUE;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 339 "rcfile_y.y"
    {current.rewrite     = FLAG_TRUE;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 340 "rcfile_y.y"
    {current.forcecr     = FLAG_TRUE;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 341 "rcfile_y.y"
    {current.stripcr     = FLAG_TRUE;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 342 "rcfile_y.y"
    {current.pass8bits   = FLAG_TRUE;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 343 "rcfile_y.y"
    {current.dropstatus  = FLAG_TRUE;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 344 "rcfile_y.y"
    {current.dropdelivered = FLAG_TRUE;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 345 "rcfile_y.y"
    {current.mimedecode  = FLAG_TRUE;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 346 "rcfile_y.y"
    {current.idle        = FLAG_TRUE;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 348 "rcfile_y.y"
    {
#ifdef SSL_ENABLE
		    current.use_ssl = FLAG_TRUE;
#else
		    yyerror(GT_("SSL is not enabled"));
#endif
		}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 355 "rcfile_y.y"
    {current.sslkey = prependdir ((yyvsp[(2) - (2)].sval), rcfiledir); free((yyvsp[(2) - (2)].sval));}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 356 "rcfile_y.y"
    {current.sslcert = prependdir ((yyvsp[(2) - (2)].sval), rcfiledir); free((yyvsp[(2) - (2)].sval));}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 357 "rcfile_y.y"
    {current.sslproto = (yyvsp[(2) - (2)].sval);}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 358 "rcfile_y.y"
    {current.sslcertck = FLAG_TRUE;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 359 "rcfile_y.y"
    {current.sslcertfile = prependdir((yyvsp[(2) - (2)].sval), rcfiledir); free((yyvsp[(2) - (2)].sval));}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 360 "rcfile_y.y"
    {current.sslcertpath = prependdir((yyvsp[(2) - (2)].sval), rcfiledir); free((yyvsp[(2) - (2)].sval));}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 361 "rcfile_y.y"
    {current.sslcommonname = (yyvsp[(2) - (2)].sval);}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 362 "rcfile_y.y"
    {current.sslfingerprint = (yyvsp[(2) - (2)].sval);}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 364 "rcfile_y.y"
    {current.keep        = FLAG_FALSE;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 365 "rcfile_y.y"
    {current.flush       = FLAG_FALSE;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 366 "rcfile_y.y"
    {current.limitflush  = FLAG_FALSE;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 367 "rcfile_y.y"
    {current.fetchall    = FLAG_FALSE;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 368 "rcfile_y.y"
    {current.rewrite     = FLAG_FALSE;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 369 "rcfile_y.y"
    {current.forcecr     = FLAG_FALSE;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 370 "rcfile_y.y"
    {current.stripcr     = FLAG_FALSE;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 371 "rcfile_y.y"
    {current.pass8bits   = FLAG_FALSE;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 372 "rcfile_y.y"
    {current.dropstatus  = FLAG_FALSE;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 373 "rcfile_y.y"
    {current.dropdelivered = FLAG_FALSE;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 374 "rcfile_y.y"
    {current.mimedecode  = FLAG_FALSE;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 375 "rcfile_y.y"
    {current.idle        = FLAG_FALSE;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 377 "rcfile_y.y"
    {current.use_ssl     = FLAG_FALSE;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 379 "rcfile_y.y"
    {current.limit       = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 380 "rcfile_y.y"
    {current.warnings    = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 381 "rcfile_y.y"
    {current.fetchlimit  = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 382 "rcfile_y.y"
    {current.fetchsizelimit = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 383 "rcfile_y.y"
    {current.fastuidl    = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 384 "rcfile_y.y"
    {current.batchlimit  = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 385 "rcfile_y.y"
    {current.expunge     = NUM_VALUE_IN((yyvsp[(2) - (2)].number));}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 387 "rcfile_y.y"
    {current.properties  = (yyvsp[(2) - (2)].sval);}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 389 "rcfile_y.y"
    {
#ifdef HAVE_LIBPWMD
		    current.pwmd_socket = ((yyvsp[(2) - (2)].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
					}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 397 "rcfile_y.y"
    {
#ifdef HAVE_LIBPWMD
		    current.pwmd_file = ((yyvsp[(2) - (2)].sval));
#else
		    yyerror(GT_("pwmd not enabled"));
#endif
					}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 406 "rcfile_y.y"
    {
#ifdef MAPI_ENABLE
		current.mapi_workstation = ((yyvsp[(2) - (2)].sval));
#else
		yyerror(GT_("MAPI is supported, but not compiled in"));
#endif
		}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 413 "rcfile_y.y"
    {
#ifdef MAPI_ENABLE
/*-----------------------------------------------------------------------------
 *  TODO: check to see if mapi_domain is specified since mapi_domain is a
 *        required option if MAPI is enabled.
 *-----------------------------------------------------------------------------*/
		current.mapi_domain = ((yyvsp[(2) - (2)].sval));
#else
		yyerror(GT_("MAPI is supported, but not compiled in"));
#endif
		}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 424 "rcfile_y.y"
    {
#ifdef MAPI_ENABLE
		uint32_t u;

		current.mapi_lcid = ((yyvsp[(2) - (2)].sval));
		if (strncmp(current.mapi_lcid, "0x", 2) != 0) {
			char tmp[8];
			/* it doesn't look like a hex id, so try to convert it from
	 		 * a string name (like "English_Australian" to a language code
	 		 * ID string (like "0x0c09")
			 */

			u = mapi_get_lcid_from_language(current.mapi_lcid);
			if (u == 0)
			    u = mapi_get_lcid_from_locale(current.mapi_lcid);

			xfree(current.mapi_lcid);
			snprintf(tmp, sizeof(tmp), "0x%04x", u);
			current.mapi_lcid = xstrdup(tmp);
		}

		u = strtol(current.mapi_lcid, NULL, 16);
		if (NULL == mapi_get_locale_from_lcid(u)) {
			printf ("Language code not recognised, using default \"en-US\" instead\n");
		}
#else
		yyerror(GT_("MAPI is supported, but not compiled in"));
#endif
		}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 453 "rcfile_y.y"
    {
#ifdef MAPI_ENABLE
		current.mapi_ldif = ((yyvsp[(2) - (2)].sval));
#else
		yyerror(GT_("MAPI is supported, but not compiled in"));
#endif
		}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 460 "rcfile_y.y"
    {
#ifdef MAPI_ENABLE
		current.mapi_profdb = prependdir ((yyvsp[(2) - (2)].sval), rcfiledir);
#else
		yyerror(GT_("MAPI is supported, but not compiled in"));
#endif
		}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 467 "rcfile_y.y"
    {
#ifdef MAPI_ENABLE
		current.mapi_profname = ((yyvsp[(2) - (2)].sval));
#else
		yyerror(GT_("MAPI is supported, but not compiled in"));
#endif
		}
    break;



/* Line 1455 of yacc.c  */
#line 2986 "rcfile_y.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 475 "rcfile_y.y"


/* lexer interface */
extern char *rcfile;
extern int prc_lineno;
extern char *yytext;
extern FILE *yyin;

static struct query *hosttail;	/* where to add new elements */

void yyerror (const char *s)
/* report a syntax error */
{
    report_at_line(stderr, 0, rcfile, prc_lineno, GT_("%s at %s"), s,
		   (yytext && yytext[0]) ? yytext : GT_("end of input"));
    prc_errflag++;
}

/** check that a configuration file is secure, returns PS_* status codes */
int prc_filecheck(const char *pathname,
		  const flag securecheck /** shortcuts permission, filetype and uid tests if false */)
{
    struct stat statbuf;

    errno = 0;

    /* special case useful for debugging purposes */
    if (strcmp("/dev/null", pathname) == 0)
	return(PS_SUCCESS);

    /* pass through the special name for stdin */
    if (strcmp("-", pathname) == 0)
	return(PS_SUCCESS);

    /* the run control file must have the same uid as the REAL uid of this
       process, it must have permissions no greater than 600, and it must not
       be a symbolic link.  We check these conditions here. */

    if (stat(pathname, &statbuf) < 0) {
	if (errno == ENOENT)
	    return(PS_SUCCESS);
	else {
	    report(stderr, "lstat: %s: %s\n", pathname, strerror(errno));
	    return(PS_IOERR);
	}
    }

    if (!securecheck)	return PS_SUCCESS;

    if (!S_ISREG(statbuf.st_mode))
    {
	fprintf(stderr, GT_("File %s must be a regular file.\n"), pathname);
	return(PS_IOERR);
    }

#ifdef __CYGWIN__
    if (cygwin_internal(CW_CHECK_NTSEC, pathname))
#endif /* __CYGWIN__ */
    if (statbuf.st_mode & (S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH | S_IXOTH))
    {
	fprintf(stderr, GT_("File %s must have no more than -rwx------ (0700) permissions.\n"),
		pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_uid != geteuid())
    {
	fprintf(stderr, GT_("File %s must be owned by you.\n"), pathname);
	return(PS_IOERR);
    }
    return(PS_SUCCESS);
}

int prc_parse_file (const char *pathname, const flag securecheck)
/* digest the configuration into a linked list of host records */
{
    prc_errflag = 0;
    querylist = hosttail = (struct query *)NULL;

    errno = 0;

    /* Check that the file is secure */
    if ( (prc_errflag = prc_filecheck(pathname, securecheck)) != 0 )
	return(prc_errflag);

    /*
     * Croak if the configuration directory does not exist.
     * This probably means an NFS mount failed and we can't
     * see a configuration file that ought to be there.
     * Question: is this a portable check? It's not clear
     * that all implementations of lstat() will return ENOTDIR
     * rather than plain ENOENT in this case...
     */
    if (errno == ENOTDIR)
	return(PS_IOERR);
    else if (errno == ENOENT)
	return(PS_SUCCESS);

    /* Open the configuration file and feed it to the lexer. */
    if (strcmp(pathname, "-") == 0)
	yyin = stdin;
    else if ((yyin = fopen(pathname,"r")) == (FILE *)NULL) {
	report(stderr, "open: %s: %s\n", pathname, strerror(errno));
	return(PS_IOERR);
    }

    yyparse();		/* parse entire file */

    fclose(yyin);	/* not checking this should be safe, file mode was r */

    if (prc_errflag)
	return(PS_SYNTAX);
    else
	return(PS_SUCCESS);
}

static void reset_server(const char *name, int skip)
/* clear the entire global record and initialize it with a new name */
{
    trailer = FALSE;
    memset(&current,'\0',sizeof(current));
    current.smtp_socket = -1;
    current.server.pollname = xstrdup(name);
    current.server.skip = skip;
    current.server.principal = (char *)NULL;
}


static void user_reset(void)
/* clear the global current record (user parameters) used by the parser */
{
    struct hostdata save;

    /*
     * Purpose of this code is to initialize the new server block, but
     * preserve whatever server name was previously set.  Also
     * preserve server options unless the command-line explicitly
     * overrides them.
     */
    save = current.server;

    memset(&current, '\0', sizeof(current));
    current.smtp_socket = -1;

    current.server = save;
}

/** append a host record to the host list */
struct query *hostalloc(struct query *init /** pointer to block containing
					       initial values */)
{
    struct query *node;

    /* allocate new node */
    node = (struct query *) xmalloc(sizeof(struct query));

    /* initialize it */
    if (init)
	memcpy(node, init, sizeof(struct query));
    else
    {
	memset(node, '\0', sizeof(struct query));
	node->smtp_socket = -1;
    }

    /* append to end of list */
    if (hosttail != (struct query *) 0)
	hosttail->next = node;	/* list contains at least one element */
    else
	querylist = node;	/* list is empty */
    hosttail = node;

    if (trailer)
	node->server.lead_server = leadentry;
    else
    {
	node->server.lead_server = NULL;
	leadentry = &node->server;
    }

    return(node);
}

static void record_current(void)
/* register current parameters and append to the host list */
{
    (void) hostalloc(&current);
    trailer = TRUE;
}

char *prependdir (const char *file, const char *dir)
/* if a filename is relative to dir, convert it to an absolute path */
{
    char *newfile;
    if (!file[0] ||			/* null path */
	file[0] == '/' ||		/* absolute path */
	strcmp(file, "-") == 0 ||	/* stdin/stdout */
	!dir[0])			/* we don't HAVE_GETCWD */
	return xstrdup (file);
    newfile = (char *)xmalloc (strlen (dir) + 1 + strlen (file) + 1);
    if (dir[strlen(dir) - 1] != '/')
	sprintf (newfile, "%s/%s", dir, file);
    else
	sprintf (newfile, "%s%s", dir, file);
    return newfile;
}

/* rcfile_y.y ends here */

